// http://blog.mridey.com/2009/09/label-overlay-example-for-google-maps.html

// Create an overlay on the map from a projected image - Maps v3...
// Author. John D. Coryat 05/2009
// USNaviguide LLC - http://www.usnaviguide.com
// Thanks go to Mile Williams EInsert: http://econym.googlepages.com/einsert.js, Google's 
// Opacity code from TPhoto: http://gmaps.tommangan.us/addtphoto.html
//
// Parameters:
//    map: This Map
//    imageUrl: URL of the image (Mandatory)
//    position: position object of image destination (Mandatory)
//    Options:
//    percentOpacity: Default 50, percent opacity to use when the image is loaded 0-100.
//

// constants
// label types
var CLICKTOVIEW=0;
var MOUSEOVER=1;
var PERMANENT=2;
// aircraft click ops
var SHOWPHOTOPANEL=0;
var SHOWCOCKPITVIEW=1;

var CIRCLE_ID=999;

var currentBoxOwner = -1;	// the index of the marker that 'owns' the box
var currentBoxDiv = null;	// the 'Div' element of the box
var circleMarker = 0;


function closeClickToViewBox()
{
   if (circleMarker != 0)
   {
      circleMarker.hide();
   }

   if (currentBoxOwner >= 0)
   {
      currentBoxDiv.style.visibility="hidden";
      currentBoxOwner = -1;
   }

   document.getElementById('mapbase').style.visibility="hidden"; 
   document.getElementById('map3d').style.visibility="hidden"; 
   GEpluginModeS="";
   roll = 0.0;
   GElastheading = -1;

}

     
function Aircraft(map, index, imageUrl, width, height, xOffset, yOffset, alt, labelHTML, detailsHTML, position, labelsReqd, labelTrans)
{
 google.maps.OverlayView.call(this);

 this.map_ = map;
 this.url_ = imageUrl;
 this.width_ = width;
 this.height_ = height;
 this.xOffset_ = xOffset;
 this.yOffset_ = yOffset;
 this.index_ = index;
 this.zIndex_ = alt;
 this.labelDiv_ = null;
 this.labelHTML_ = labelHTML +'</div>';
 this.detailsHTML_ = detailsHTML + '</div>';
 this.labelsReqd_ = labelsReqd;
 this.position_ = position;
 this.heading_ = -1;
 this.speed_ = -1;
 this.verticalVelocity_ = 0;
 this.percentOpacity_ = labelTrans;
 this.created_ = 0;
 this.myProjection_ = 0;
 this.redrawn_ = 0;
 this.throttle_ = 1.0;

 this.setMap(map);
}

Aircraft.prototype = new google.maps.OverlayView();

Aircraft.prototype.createElement = function()
{
 var panes = this.getPanes();
 var div = this.div_ ;

 if (!div)
 {
  div = this.div_ = document.createElement("div");
  div.style.position = "absolute";
  div.style.zIndex = this.zIndex_;
  this.div_ = div;

  panes.overlayImage.appendChild(div);

     this.labelDiv_ = document.createElement("div");
     this.labelDiv_.innerHTML = "";
     var labelDiv = this.labelDiv_;
     var required = this.labelsReqd_;

     labelDiv.style.position = "absolute";
     labelDiv.style.zIndex = this.zIndex_;

     if( this.percentOpacity_ )
     {
        this.setOpacity(this.percentOpacity_);
     }

     this.labelDiv_.style.visibility = "hidden";

     if (required == CLICKTOVIEW)
     {
        this.labelDiv_.style.visibility = "visible";
     }

     if (required == PERMANENT)
     {
        this.labelDiv_.style.visibility = "visible";
     }

     var index = this.index_;
     var position = this.position_;

     if (index != CIRCLE_ID)
     {
        this.listeners_ =
        [
           google.maps.event.addDomListener(this.div_, 'mouseover', function(event) {  onMouseOver(labelDiv,required); }),
           google.maps.event.addDomListener(this.div_, 'mouseout',  function(event) {  onMouseOut(labelDiv,required);  }),
           google.maps.event.addDomListener(this.div_, 'click',  function(event) {
onIconClick(index,position,required);  })
        ];
     }

    panes.overlayImage.appendChild(labelDiv);
  }
}

function onIconClick(index, position, required)
{
   if (required == CLICKTOVIEW)
   {
      if (circleMarker == 0)
      {
         var myLatLng = new google.maps.LatLng(mapMarkers[index].position_.lng(), mapMarkers[index].position_.lat());
         circleMarker = new Aircraft(map, CIRCLE_ID, "Circle.png", 32, 32, 0, 0, -2000, "","", myLatLng, Lbls, lblTrns);
      }

      if (currentBoxDiv == null)
      {
         currentBoxOwner = -1;
         currentBoxDiv = document.getElementById('info');
         currentBoxDiv.innerHTML = "";
         currentBoxDiv.style.visibility = "hidden";
         var mapDiv = map.getDiv();
         mapDiv.appendChild(currentBoxDiv);
      }

      currentBoxOwner = index;

      if (GEPluginOp == SHOWCOCKPITVIEW)
      {
         ShowGEPlugin(flights[index], mapMarkers[index].position_.lat(), mapMarkers[index].position_.lng());
      }
      else
      {
         currentBoxDiv.style.visibility = "visible";
         currentBoxDiv.innerHTML = mapMarkers[index].detailsHTML_;
      }

      GEPluginAircraftChange(index);

      circleMarker.position_ = mapMarkers[index].position_;
      circleMarker.xOffset_ = mapMarkers[index].xOffset_ - 4;
      circleMarker.yOffset_ = mapMarkers[index].yOffset_ - 4;
      circleMarker.zIndex_ = mapMarkers[index].zIndex_ - 1;

      circleMarker.show();
      circleMarker.draw();
   }
}

function onMouseOver(label, required)
{
   if (required != MOUSEOVER)
   {
      return;
   }

   label.style.visibility = "visible";
} 


function onMouseOut(label, required)
{
   if (required != MOUSEOVER)
   {
      return;
   }

   label.style.visibility = "hidden";
} 


// Remove the main DIV from the map pane

Aircraft.prototype.remove = function()
{
  if (this.div_) 
  {
     numToDelete--;

/*
     // Aircraft is removed from the map, stop updating its position/text.
alert("remove " + this.listeners_.length + " listeners");
     for (var i = 0, I = this.listeners_.length; i < I; ++i)
     {
        google.maps.event.removelistener(this.listeners_[i]);
     }
*/

     this.setMap(null);
     this.div_.innerHTML = "";
     this.div_.parentNode.removeChild(this.div_);
     this.div_ = null;

     if (this.labelDiv_ != null)
     {
        this.labelDiv_.parentNode.removeChild(this.labelDiv_);
        this.labelDiv_ = null;
     }

     if (currentBoxOwner == this.index_)
     {
        closeClickToViewBox();
     }
  }
}

Aircraft.prototype.hide = function()
{
   if (this.div_)
   {
      this.div_.style.visibility = "hidden";
      this.labelDiv_.style.visibility = "hidden";

      if (currentBoxOwner == this.index_)
      {
         closeClickToViewBox();
      }
   }
}

Aircraft.prototype.show = function()
{
   if (this.div_)
   {
      this.div_.style.visibility = "visible";
      this.labelDiv_.style.visibility = "visible";
   }
}

Aircraft.prototype.zindex = function()
{
   return this.zIndex_;
}

Aircraft.prototype.heading = function()
{
   return this.heading_;
}

Aircraft.prototype.speed = function()
{
   return this.speed_;
}

Aircraft.prototype.throttle = function()
{
   return this.throttle_;
}

Aircraft.prototype.verticalVelocity = function()
{
   return this.verticalVelocity_;
}

Aircraft.prototype.position = function()
{
   return this.position_;
}

Aircraft.prototype.getRedrawn = function()
{
   return this.redrawn_;
}

Aircraft.prototype.setRedrawn = function(value)
{
   this.redrawn_ = value;
}

Aircraft.prototype.visible = function()
{
   if (this.div_)
   {
      if (this.div_.style.visibility == "hidden")
      {
         return 0;
      }
      else
      { 
         return 1;
      }
   }
}


Aircraft.prototype.draw = function()
{
 if (this.created_ == 0)
 {
   this.createElement();

   if (!this.div_)
   {
     alert("draw error");
     return ;
   }

   this.created_ = 1;

   this.myProjection_ = this.get('projection');
 }

 var c1 = this.myProjection_.fromLatLngToDivPixel(this.position_);
 this.div_.style.left = (c1.x + this.xOffset_) + "px";
 this.div_.style.top = (c1.y + this.yOffset_) + "px";
 this.div_.style.width = this.width_ + "px";
 this.div_.style.height = this.height_ + "px";
 this.div_.style.zIndex = this.zIndex_;

 this.div_.innerHTML = '<div class="aircrafticon"><img src="' + this.url_ + '"  width=' + this.div_.style.width  + ' height=' + 
      this.div_.style.height + ' ></div>';

 if (this.labelDiv_ != null && this.labelHTML_.length > 0)
 {
    this.labelDiv_.style.left = (c1.x + this.xOffset_) + "px";
    this.labelDiv_.style.top = (c1.y + this.yOffset_ + this.height_) + "px";
    this.labelDiv_.style.zIndex = this.zIndex_;
    this.labelDiv_.innerHTML = this.labelHTML_;
 }
}

Aircraft.prototype.setPosition=function(index,position,zIndex,heading,speed,verticalVelocity,labelHTML,detailsHTML)
{
  if (this.div_)
  {
     this.zIndex_ = zIndex;
     this.position_ = position;
     this.heading_ = heading;
     this.speed_ = speed;
     this.verticalVelocity_ = verticalVelocity;
     this.labelHTML_ = labelHTML + 
// ANDY FIX
//      " T:" + this.throttle_.toFixed(2)  + 
    '</div>';
     this.detailsHTML_ = detailsHTML + '</div>'

     this.draw();

     if (currentBoxOwner == this.index_)
     {
        currentBoxDiv.innerHTML = detailsHTML + '</div>';
        circleMarker.position_ = position;
        circleMarker.zIndex_ = mapMarkers[index].zIndex_ - 1;
        circleMarker.draw();
     }
  }
}

Aircraft.prototype.updatePosition=function(index,position,zIndex)
{
  if (this.div_)
  {
     this.position_ = position;
     this.zIndex_ = zIndex;

     this.draw();

     if (currentBoxOwner == this.index_)
     {
        circleMarker.position_ = position;
        circleMarker.zIndex_ = mapMarkers[index].zIndex_ - 1;
        circleMarker.draw();
     }
  }
}

Aircraft.prototype.getIcon=function()
{
   return this.url_;
}

Aircraft.prototype.setIcon=function(newImageURL)
{
   this.url_ = newImageURL;
}

Aircraft.prototype.setOffsets=function(newXOffset,newYOffset)
{
   this.xOffset_ = newXOffset;
   this.yOffset_ = newYOffset;

   if (currentBoxOwner == this.index_)
   {
      circleMarker.xOffset_ = newXOffset - 4;
      circleMarker.yOffset_ = newYOffset - 4;
   }
}


Aircraft.prototype.setThrottle=function(newThrottle)
{
  if (this.div_)
  {
     this.throttle_ = newThrottle;
  }
}


Aircraft.prototype.setOpacity=function(opacity)
{
 if (opacity < 0)
 {
  opacity = 0;
 }
 if(opacity > 100)
 {
  opacity = 100;
 }
 var c = opacity/100;

 if (typeof(this.labelDiv_.style.filter) =='string')
 {
   this.labelDiv_.style.filter = 'alpha(opacity:' + opacity + ')';
 }
 if (typeof(this.labelDiv_.style.KHTMLOpacity) == 'string' )
 {
   this.labelDiv_.style.KHTMLOpacity = c;
 }
 if (typeof(this.labelDiv_.style.MozOpacity) == 'string')
 {
  this.labelDiv_.style.MozOpacity = c;
 }
 if (typeof(this.labelDiv_.style.opacity) == 'string')
 {
  this.labelDiv_.style.opacity = c;
 }
}


